CPP      = mpiicpc
CC       = mpiicc

LIBBLASLAPACK = -lmkl_lapack95_lp64 -lmkl_blas95_lp64 -mkl=cluster -lifcore -lm -lstdc++

HYPREFLAGS = -g -Wall -DHAVE_CONFIG_H -DHYPRE_TIMING -mkl=cluster
HYPREINC   = -I${HYPRE_DIR}/include
LIBHYPRE   = -L${HYPRE_DIR}/lib -lHYPRE

PETSCFLAGS = -fPIC -O2 -march=native -mtune=native -mkl=cluster -lifcore -std=c99  
PETSCINC   = -I${PETSC_DIR}/include -I${HYPRE_DIR}/include -I${MUMPS_DIR}/include -I${PARMETIS_DIR}/include -I${INTEL_MPI_DIR}/include
LIBPETSC   = -Wl,-rpath,/share/home/hhxie/liyu/soft/petsc/lib -L/share/home/hhxie/liyu/soft/petsc/lib -Wl,-rpath,/share/home/hhxie/liyu/soft/hypre/lib -L/share/home/hhxie/liyu/soft/hypre/lib -Wl,-rpath,/share/home/hhxie/liyu/soft/mumps/lib -L/share/home/hhxie/liyu/soft/mumps/lib -Wl,-rpath,/soft/apps/intel/oneapi_base_2021/mkl/2021.1.1/lib/intel64 -L/soft/apps/intel/oneapi_base_2021/mkl/2021.1.1/lib/intel64 -Wl,-rpath,/share/home/hhxie/liyu/soft/parmetis/lib -L/share/home/hhxie/liyu/soft/parmetis/lib -Wl,-rpath,/soft/apps/intel/oneapi_hpc_2021/mpi/2021.1.1/lib -L/soft/apps/intel/oneapi_hpc_2021/mpi/2021.1.1/lib -Wl,-rpath,/soft/apps/intel/oneapi_hpc_2021/mpi/2021.1.1/lib/release -L/soft/apps/intel/oneapi_hpc_2021/mpi/2021.1.1/lib/release -Wl,-rpath,/soft/apps/intel/oneapi_base_2021/tbb/2021.1.1/lib/intel64/gcc4.8 -L/soft/apps/intel/oneapi_base_2021/tbb/2021.1.1/lib/intel64/gcc4.8 -Wl,-rpath,/soft/apps/intel/oneapi_base_2021/compiler/2021.1.1/linux/lib -L/soft/apps/intel/oneapi_base_2021/compiler/2021.1.1/linux/lib -Wl,-rpath,/soft/apps/intel/oneapi_hpc_2021/compiler/2021.1.1/linux/lib -L/soft/apps/intel/oneapi_hpc_2021/compiler/2021.1.1/linux/lib -Wl,-rpath,/soft/apps/intel/oneapi_hpc_2021/mpi/2021.1.1/libfabric/lib -L/soft/apps/intel/oneapi_hpc_2021/mpi/2021.1.1/libfabric/lib -Wl,-rpath,/soft/apps/intel/oneapi_hpc_2021/compiler/2021.1.1/linux/compiler/lib/intel64_lin -L/soft/apps/intel/oneapi_hpc_2021/compiler/2021.1.1/linux/compiler/lib/intel64_lin -Wl,-rpath,/soft/apps/intel/oneapi_base_2021/mkl/2021.1.1/lib/intel64_lin -L/soft/apps/intel/oneapi_base_2021/mkl/2021.1.1/lib/intel64_lin -Wl,-rpath,/usr/lib/gcc/x86_64-redhat-linux/4.8.5 -L/usr/lib/gcc/x86_64-redhat-linux/4.8.5 -lpetsc -lHYPRE -lmumps -lmkl_scalapack_lp64 -lmkl_lapack95_lp64 -lmkl_blas95_lp64 -lparmetis -lmetis -lmpi -lstdc++ -ldl -lmpifort -lmpi -lrt -lpthread -lmkl_intel_lp64 -lmkl_cdft_core -lmkl_scalapack_lp64 -lmkl_blacs_intelmpi_lp64 -lmkl_sequential -lmkl_core -liomp5 -lifport -lifcoremt_pic -limf -lsvml -lm -lipgo -lirc -lgcc_s -lirc_s -lquadmath -lstdc++ -ldl

SLEPCFLAGS = -fPIC -O2 -march=native -mtune=native -mkl=cluster -lifcore -std=c99
SLEPCINC   = -I${SLEPC_DIR}/include -I${PETSC_DIR}/include -I${HYPRE_DIR}/include -I${MUMPS_DIR}/include -I${PARMETIS_DIR}/include -I${INTEL_MPI_DIR}/include
LIBSLEPC   = -Wl,-rpath,/share/home/hhxie/liyu/soft/slepc/lib -L/share/home/hhxie/liyu/soft/slepc/lib -lslepc -Wl,-rpath,/share/home/hhxie/liyu/soft/petsc/lib -L/share/home/hhxie/liyu/soft/petsc/lib -Wl,-rpath,/share/home/hhxie/liyu/soft/hypre/lib -L/share/home/hhxie/liyu/soft/hypre/lib -Wl,-rpath,/share/home/hhxie/liyu/soft/mumps/lib -L/share/home/hhxie/liyu/soft/mumps/lib -Wl,-rpath,/soft/apps/intel/oneapi_base_2021/mkl/2021.1.1/lib/intel64 -L/soft/apps/intel/oneapi_base_2021/mkl/2021.1.1/lib/intel64 -Wl,-rpath,/share/home/hhxie/liyu/soft/parmetis/lib -L/share/home/hhxie/liyu/soft/parmetis/lib -Wl,-rpath,/soft/apps/intel/oneapi_hpc_2021/mpi/2021.1.1/lib -L/soft/apps/intel/oneapi_hpc_2021/mpi/2021.1.1/lib -Wl,-rpath,/soft/apps/intel/oneapi_hpc_2021/mpi/2021.1.1/lib/release -L/soft/apps/intel/oneapi_hpc_2021/mpi/2021.1.1/lib/release -Wl,-rpath,/soft/apps/intel/oneapi_base_2021/tbb/2021.1.1/lib/intel64/gcc4.8 -L/soft/apps/intel/oneapi_base_2021/tbb/2021.1.1/lib/intel64/gcc4.8 -Wl,-rpath,/soft/apps/intel/oneapi_base_2021/compiler/2021.1.1/linux/lib -L/soft/apps/intel/oneapi_base_2021/compiler/2021.1.1/linux/lib -Wl,-rpath,/soft/apps/intel/oneapi_hpc_2021/compiler/2021.1.1/linux/lib -L/soft/apps/intel/oneapi_hpc_2021/compiler/2021.1.1/linux/lib -Wl,-rpath,/soft/apps/intel/oneapi_hpc_2021/mpi/2021.1.1/libfabric/lib -L/soft/apps/intel/oneapi_hpc_2021/mpi/2021.1.1/libfabric/lib -Wl,-rpath,/soft/apps/intel/oneapi_hpc_2021/compiler/2021.1.1/linux/compiler/lib/intel64_lin -L/soft/apps/intel/oneapi_hpc_2021/compiler/2021.1.1/linux/compiler/lib/intel64_lin -Wl,-rpath,/soft/apps/intel/oneapi_base_2021/mkl/2021.1.1/lib/intel64_lin -L/soft/apps/intel/oneapi_base_2021/mkl/2021.1.1/lib/intel64_lin -Wl,-rpath,/usr/lib/gcc/x86_64-redhat-linux/4.8.5 -L/usr/lib/gcc/x86_64-redhat-linux/4.8.5 -lpetsc -lHYPRE -lmumps -lmkl_scalapack_lp64 -lmkl_lapack95_lp64 -lmkl_blas95_lp64 -lparmetis -lmetis -lmpi -lstdc++ -ldl -lmpifort -lmpi -lrt -lpthread -lmkl_intel_lp64 -lmkl_cdft_core -lmkl_scalapack_lp64 -lmkl_blacs_intelmpi_lp64 -lmkl_sequential -lmkl_core -liomp5 -lifport -lifcoremt_pic -limf -lsvml -lm -lipgo -lirc -lgcc_s -lirc_s -lquadmath -lstdc++ -ldl

PHGFLAGS   = -O2 -fPIC -w -qopenmp -D__PHG__
PHGINC     = -I${PHG_DIR}/include -I${SLEPC_DIR}/include -I${PETSC_DIR}/include -I${HYPRE_DIR}/include -I${MUMPS_DIR}/include -I${PARMETIS_DIR}/include -I${INTEL_MPI_DIR}/include
LIBPHG     = -qopenmp -L/share/home/hhxie/liyu/soft/phg/lib -Wl,-rpath,/share/home/hhxie/liyu/soft/phg/lib -lphg  -lgmp  -Wl,-rpath,/share/home/hhxie/liyu/soft/slepc/lib  -lslepc  -lmumps  /soft/apps/intel/oneapi_base_2021/mkl/2021.1.1/lib/intel64/libmkl_scalapack_lp64.a /share/home/hhxie/liyu/soft/parmetis/lib/libparmetis.a /share/home/hhxie/liyu/soft/parmetis/lib/libmetis.a  /soft/apps/intel/oneapi_base_2021/mkl/2021.1.1/lib/intel64/libmkl_lapack95_lp64.a  /soft/apps/intel/oneapi_base_2021/mkl/2021.1.1/lib/intel64/libmkl_blas95_lp64.a  -Wl,-rpath,/share/home/hhxie/liyu/soft/petsc/lib -L/share/home/hhxie/liyu/soft/petsc/lib -Wl,-rpath,/share/home/hhxie/liyu/soft/hypre/lib -L/share/home/hhxie/liyu/soft/hypre/lib -Wl,-rpath,/share/home/hhxie/liyu/soft/mumps/lib -L/share/home/hhxie/liyu/soft/mumps/lib -Wl,-rpath,/soft/apps/intel/oneapi_base_2021/mkl/2021.1.1/lib/intel64 -Wl,-rpath,/share/home/hhxie/liyu/soft/parmetis/lib -L/share/home/hhxie/liyu/soft/parmetis/lib -Wl,-rpath,/soft/apps/intel/oneapi_hpc_2021/mpi/2021.1.1/lib -Wl,-rpath,/soft/apps/intel/oneapi_hpc_2021/mpi/2021.1.1/lib/release -Wl,-rpath,/soft/apps/intel/oneapi_base_2021/tbb/2021.1.1/lib/intel64/gcc4.8 -L/soft/apps/intel/oneapi_base_2021/tbb/2021.1.1/lib/intel64/gcc4.8 -Wl,-rpath,/soft/apps/intel/oneapi_base_2021/compiler/2021.1.1/linux/lib -L/soft/apps/intel/oneapi_base_2021/compiler/2021.1.1/linux/lib -Wl,-rpath,/soft/apps/intel/oneapi_hpc_2021/compiler/2021.1.1/linux/lib -Wl,-rpath,/soft/apps/intel/oneapi_hpc_2021/mpi/2021.1.1/libfabric/lib -Wl,-rpath,/soft/apps/intel/oneapi_hpc_2021/compiler/2021.1.1/linux/compiler/lib/intel64_lin -L/soft/apps/intel/oneapi_hpc_2021/compiler/2021.1.1/linux/compiler/lib/intel64_lin -Wl,-rpath,/soft/apps/intel/oneapi_base_2021/mkl/2021.1.1/lib/intel64_lin -Wl,-rpath,/usr/lib/gcc/x86_64-redhat-linux/4.8.5 -L/usr/lib/gcc/x86_64-redhat-linux/4.8.5 -lpetsc -lHYPRE -lmumps -lmkl_scalapack_lp64 -lmkl_lapack95_lp64 -lmkl_blas95_lp64 -lparmetis -lmetis -lmpi -lstdc++ -ldl -lmpifort -lmpi -lrt -lpthread -lmkl_intel_lp64 -lmkl_cdft_core -lmkl_scalapack_lp64 -lmkl_blacs_intelmpi_lp64 -lmkl_sequential -lmkl_core -liomp5 -lifport -lifcoremt_pic -limf -lsvml -lm -lipgo -lirc -lgcc_s -lirc_s -lquadmath -lstdc++ -ldl  -lmpi -mkl=cluster -lm  -L/soft/apps/intel/oneapi_hpc_2021/mpi/2021.1.1/lib/release -L/soft/apps/intel/oneapi_hpc_2021/mpi/2021.1.1/lib -L/soft/apps/intel/oneapi_base_2021/mkl/2021.1.1/lib/intel64 -L/soft/apps/intel/oneapi_base_2021/mkl/../tbb/2021.1.1/lib/intel64/gcc4.8 -L/soft/apps/intel/oneapi_base_2021/mkl/../compiler/2021.1.1/linux/lib -L/soft/apps/intel/oneapi_hpc_2021/compiler/2021.1.1/linux/lib -L/soft/apps/intel/oneapi_hpc_2021/mpi/2021.1.1/libfabric/lib -L/soft/apps/intel/oneapi_hpc_2021/compiler/2021.1.1/linux/bin/intel64/../../compiler/lib/intel64_lin -L/soft/apps/intel/oneapi_base_2021/mkl/2021.1.1/lib/intel64_lin -L/usr/lib/gcc/x86_64-redhat-linux/4.8.5/ -L/usr/lib/gcc/x86_64-redhat-linux/4.8.5/../../../../lib64 -L/usr/lib/gcc/x86_64-redhat-linux/4.8.5/../../../../lib64/ -L/lib/../lib64 -L/lib/../lib64/ -L/usr/lib/../lib64 -L/usr/lib/../lib64/ -L/soft/apps/intel/oneapi_base_2021/mkl/2021.1.1/lib/intel64/ -L/soft/apps/intel/oneapi_base_2021/mkl/../tbb/2021.1.1/lib/intel64/gcc4.8/ -L/soft/apps/intel/oneapi_base_2021/mkl/../compiler/2021.1.1/linux/lib/ -L/soft/apps/intel/oneapi_hpc_2021/compiler/2021.1.1/linux/lib/ -L/soft/apps/intel/oneapi_hpc_2021/mpi/2021.1.1/libfabric/lib/ -L/soft/apps/intel/oneapi_hpc_2021/mpi/2021.1.1/lib/release/ -L/soft/apps/intel/oneapi_hpc_2021/mpi/2021.1.1/lib/ -L/usr/lib/gcc/x86_64-redhat-linux/4.8.5/../../../ -L/lib64 -L/lib/ -L/usr/lib64 -L/usr/lib -lmkl_intel_lp64 -lmkl_cdft_core -lmkl_scalapack_lp64 -lmkl_blacs_intelmpi_lp64 -lmkl_sequential -lmkl_core -liomp5 -limf -lm -lmpifort -lmpi -ldl -lrt -lpthread -lifport -lifcoremt_pic -lsvml -lipgo -lirc -lirc_s  -lmkl_intel_lp64 -lmkl_cdft_core -lmkl_scalapack_lp64 -lmkl_blacs_intelmpi_lp64 -lmkl_sequential -lmkl_core -liomp5 -limf -lm -lmpifort -lmpi -ldl -lrt -lpthread -lifport -lifcoremt_pic -lsvml -lipgo -lirc -lirc_s -Wl,-rpath,/usr/local/lib -Wl,-rpath,/usr/local/lib64
