CPP      = mpiicpc
CC       = mpiicc

LIBBLASLAPACK = -lmkl_lapack95_lp64 -lmkl_blas95_lp64 -mkl=cluster -lifcore -lm

HYPREFLAGS = -fPIC -O2 -qopenmp -DHAVE_CONFIG_H
HYPREINC   = -I/share/home/hhxie/liyu/soft/hypre/include
LIBHYPRE   = -L/share/home/hhxie/liyu/soft/hypre/lib -lHYPRE

PETSCFLAGS = -fPIC -O2 -march=native -mtune=native -mkl=cluster -lifcore  -fPIC -O2 -march=native -mtune=native -mkl=cluster -lifcore  -std=c99
PETSCINC   = -I/share/home/hhxie/liyu/soft/petsc/include -I/share/home/hhxie/liyu/soft/hypre/include -I/share/home/hhxie/liyu/soft/mumps/include -I/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mpi/intel64/include
LIBPETSC   = -Wl,-rpath,/share/home/hhxie/liyu/soft/petsc/lib -L/share/home/hhxie/liyu/soft/petsc/lib -Wl,-rpath,/share/home/hhxie/liyu/soft/hypre/lib -L/share/home/hhxie/liyu/soft/hypre/lib -Wl,-rpath,/share/home/hhxie/liyu/soft/mumps/lib -L/share/home/hhxie/liyu/soft/mumps/lib -Wl,-rpath,/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mkl/lib/intel64 -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mkl/lib/intel64 -Wl,-rpath,/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mpi/intel64/lib -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mpi/intel64/lib -Wl,-rpath,/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mpi/intel64/lib/release_mt -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mpi/intel64/lib/release_mt -Wl,-rpath,/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/tbb/lib/intel64_lin/gcc4.4 -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/tbb/lib/intel64_lin/gcc4.4 -Wl,-rpath,/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/daal/lib/intel64_lin -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/daal/lib/intel64_lin -Wl,-rpath,/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/tbb/lib/intel64/gcc4.4 -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/tbb/lib/intel64/gcc4.4 -Wl,-rpath,/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/compiler/lib/intel64 -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/compiler/lib/intel64 -Wl,-rpath,/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/ipp/lib/intel64 -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/ipp/lib/intel64 -Wl,-rpath,/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/compiler/lib/intel64_lin -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/compiler/lib/intel64_lin -Wl,-rpath,/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mkl/lib/intel64_lin -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mkl/lib/intel64_lin -Wl,-rpath,/usr/lib/gcc/x86_64-redhat-linux/4.8.5 -L/usr/lib/gcc/x86_64-redhat-linux/4.8.5 -Wl,-rpath,/opt/intel/mpi-rt/2017.0.0/intel64/lib/release_mt -Wl,-rpath,/opt/intel/mpi-rt/2017.0.0/intel64/lib -lpetsc -lHYPRE -lmumps -lmkl_scalapack_lp64 -lmkl_lapack95_lp64 -lmkl_blas95_lp64 -lmpi -lstdc++ -ldl -lmpifort -lmpi -lmpigi -lrt -lpthread -lmkl_intel_lp64 -lmkl_cdft_core -lmkl_scalapack_lp64 -lmkl_blacs_intelmpi_lp64 -lmkl_sequential -lmkl_core -liomp5 -lifport -lifcoremt_pic -limf -lsvml -lm -lipgo -lirc -lgcc_s -lirc_s -lquadmath -lstdc++ -ldl


SLEPCFLAGS = -fPIC -O2 -march=native -mtune=native -mkl=cluster -lifcore  -fPIC -O2 -march=native -mtune=native -mkl=cluster -lifcore -std=c99
SLEPCINC   = -I/share/home/hhxie/liyu/soft/slepc/include -I/share/home/hhxie/liyu/soft/slepc/include -I/share/home/hhxie/liyu/soft/petsc/include -I/share/home/hhxie/liyu/soft/hypre/include -I/share/home/hhxie/liyu/soft/mumps/include -I/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mpi/intel64/include
LIBSLEPC   = -Wl,-rpath,/share/home/hhxie/liyu/soft/slepc/lib -L/share/home/hhxie/liyu/soft/slepc/lib -lslepc -Wl,-rpath,/share/home/hhxie/liyu/soft/petsc/lib -L/share/home/hhxie/liyu/soft/petsc/lib -Wl,-rpath,/share/home/hhxie/liyu/soft/hypre/lib -L/share/home/hhxie/liyu/soft/hypre/lib -Wl,-rpath,/share/home/hhxie/liyu/soft/mumps/lib -L/share/home/hhxie/liyu/soft/mumps/lib -Wl,-rpath,/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mkl/lib/intel64 -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mkl/lib/intel64 -Wl,-rpath,/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mpi/intel64/lib -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mpi/intel64/lib -Wl,-rpath,/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mpi/intel64/lib/release_mt -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mpi/intel64/lib/release_mt -Wl,-rpath,/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/tbb/lib/intel64_lin/gcc4.4 -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/tbb/lib/intel64_lin/gcc4.4 -Wl,-rpath,/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/daal/lib/intel64_lin -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/daal/lib/intel64_lin -Wl,-rpath,/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/tbb/lib/intel64/gcc4.4 -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/tbb/lib/intel64/gcc4.4 -Wl,-rpath,/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/compiler/lib/intel64 -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/compiler/lib/intel64 -Wl,-rpath,/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/ipp/lib/intel64 -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/ipp/lib/intel64 -Wl,-rpath,/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/compiler/lib/intel64_lin -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/compiler/lib/intel64_lin -Wl,-rpath,/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mkl/lib/intel64_lin -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mkl/lib/intel64_lin -Wl,-rpath,/usr/lib/gcc/x86_64-redhat-linux/4.8.5 -L/usr/lib/gcc/x86_64-redhat-linux/4.8.5 -Wl,-rpath,/opt/intel/mpi-rt/2017.0.0/intel64/lib/release_mt -Wl,-rpath,/opt/intel/mpi-rt/2017.0.0/intel64/lib -lpetsc -lHYPRE -lmumps -lmkl_scalapack_lp64 -lmkl_lapack95_lp64 -lmkl_blas95_lp64 -lmpi -lstdc++ -ldl -lmpifort -lmpi -lmpigi -lrt -lpthread -lmkl_intel_lp64 -lmkl_cdft_core -lmkl_scalapack_lp64 -lmkl_blacs_intelmpi_lp64 -lmkl_sequential -lmkl_core -liomp5 -lifport -lifcoremt_pic -limf -lsvml -lm -lipgo -lirc -lgcc_s -lirc_s -lquadmath -lstdc++ -ldl


PHGFLAGS   = -O2 -fPIC -w -qopenmp -D__PHG__
PHGINC     = -I/share/home/hhxie/liyu/phg-0.9.5/include -I/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mpi/intel64/include -I/share/home/hhxie/liyu/soft/petsc/include -I/share/home/hhxie/liyu/soft/hypre/include -I/share/home/hhxie/liyu/soft/mumps/include -I/share/home/hhxie/liyu/soft/hypre-2.19.0/include -I/share/home/hhxie/liyu/soft/slepc/include
LIBPHG     = -L/share/home/hhxie/liyu/phg-0.9.5/src -qopenmp -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mpi/intel64/lib -L/share/home/hhxie/liyu/soft/petsc/lib -L/share/home/hhxie/liyu/soft/hypre-2.19.0/lib -L/share/home/hhxie/liyu/soft/mumps/lib -L/share/home/hhxie/liyu/soft/slepc/lib -Wl,-rpath,/share/home/hhxie/liyu/phg-0.9.5/src -lphg  -lgmp  -Wl,-rpath,/share/home/hhxie/liyu/soft/slepc/lib  -lslepc  -lmumps  /soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mkl/lib/intel64/libmkl_scalapack_lp64.a  /soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mkl/lib/intel64/libmkl_lapack95_lp64.a  /soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mkl/lib/intel64/libmkl_blas95_lp64.a  -Wl,-rpath,/share/home/hhxie/liyu/soft/petsc/lib -L/share/home/hhxie/liyu/soft/petsc/lib -Wl,-rpath,/share/home/hhxie/liyu/soft/hypre/lib -L/share/home/hhxie/liyu/soft/hypre/lib -Wl,-rpath,/share/home/hhxie/liyu/soft/mumps/lib -L/share/home/hhxie/liyu/soft/mumps/lib -Wl,-rpath,/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mkl/lib/intel64 -Wl,-rpath,/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mpi/intel64/lib -Wl,-rpath,/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mpi/intel64/lib/release_mt -Wl,-rpath,/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/tbb/lib/intel64_lin/gcc4.4 -Wl,-rpath,/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/daal/lib/intel64_lin -Wl,-rpath,/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/tbb/lib/intel64/gcc4.4 -Wl,-rpath,/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/compiler/lib/intel64 -Wl,-rpath,/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/ipp/lib/intel64 -Wl,-rpath,/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/compiler/lib/intel64_lin -Wl,-rpath,/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mkl/lib/intel64_lin -Wl,-rpath,/usr/lib/gcc/x86_64-redhat-linux/4.8.5 -L/usr/lib/gcc/x86_64-redhat-linux/4.8.5 -Wl,-rpath,/opt/intel/mpi-rt/2017.0.0/intel64/lib/release_mt -Wl,-rpath,/opt/intel/mpi-rt/2017.0.0/intel64/lib -lpetsc -lHYPRE -lmumps -lmkl_scalapack_lp64 -lmkl_lapack95_lp64 -lmkl_blas95_lp64 -lmpi -lstdc++ -ldl -lmpifort -lmpi -lmpigi -lrt -lpthread -lmkl_intel_lp64 -lmkl_cdft_core -lmkl_scalapack_lp64 -lmkl_blacs_intelmpi_lp64 -lmkl_sequential -lmkl_core -liomp5 -lifport -lifcoremt_pic -limf -lsvml -lm -lipgo -lirc -lgcc_s -lirc_s -lquadmath -lstdc++ -ldl  -lmpi -mkl=cluster -lm  -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mpi/intel64/lib/release_mt -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mpi/intel64/lib -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/tbb/lib/intel64_lin/gcc4.4 -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/daal/lib/intel64_lin -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/tbb/lib/intel64/gcc4.4 -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mkl/lib/intel64 -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/compiler/lib/intel64 -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/ipp/lib/intel64 -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/compiler/lib/intel64_lin -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mkl/lib/intel64_lin -L/usr/lib/gcc/x86_64-redhat-linux/4.8.5/ -L/usr/lib/gcc/x86_64-redhat-linux/4.8.5/../../../../lib64 -L/usr/lib/gcc/x86_64-redhat-linux/4.8.5/../../../../lib64/ -L/lib/../lib64 -L/lib/../lib64/ -L/usr/lib/../lib64 -L/usr/lib/../lib64/ -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/tbb/lib/intel64_lin/gcc4.4/ -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/daal/lib/intel64_lin/ -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/tbb/lib/intel64/gcc4.4/ -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/mkl/lib/intel64/ -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/compiler/lib/intel64/ -L/soft/apps/intel/2018u4/compilers_and_libraries_2018.5.274/linux/ipp/lib/intel64/ -L/usr/lib/gcc/x86_64-redhat-linux/4.8.5/../../../ -L/lib64 -L/lib/ -L/usr/lib64 -L/usr/lib -lmkl_intel_lp64 -lmkl_cdft_core -lmkl_scalapack_lp64 -lmkl_blacs_intelmpi_lp64 -lmkl_sequential -lmkl_core -liomp5 -limf -lm -lmpifort -lmpi -lmpigi -ldl -lrt -lpthread -lifport -lifcoremt_pic -lsvml -lipgo -lirc -lirc_s  -lmkl_intel_lp64 -lmkl_cdft_core -lmkl_scalapack_lp64 -lmkl_blacs_intelmpi_lp64 -lmkl_sequential -lmkl_core -liomp5 -limf -lm -lmpifort -lmpi -lmpigi -ldl -lrt -lpthread -lifport -lifcoremt_pic -lsvml -lipgo -lirc -lirc_s -Wl,-rpath,/usr/local/lib -Wl,-rpath,/usr/local/lib64
